import java.util.Arrays;

public class MyArrayList<T> {

    private T[] array;

    public MyArrayList(){
    this.array = (T[]) new Object[0];
    }

    public MyArrayList(int size){
        this.array = (T[]) new Object[size];
    }

    //T[] myList = (T[]) Array.newInstance(array.getClass().getComponentType(), array.length + 1);

    public int size(){
        return array.length;
    }

    public void add(int index, T t){
        T[] newArray = Arrays.copyOf(this.array, index + 1);
        newArray[index] = t;
        this.array = newArray;
    }

    public void add(T t){
        T[] newArray = Arrays.copyOf(this.array, array.length + 1);
        newArray[newArray.length - 1] = t;
        this.array = newArray;
    }

    public T get(int index){
        return array[index];
    }

    public void remove(int index){
        T[] newArray = Arrays.copyOf(this.array, array.length - 1);
        this.array = newArray;
    }

    public void clear(){
        T[] newArray = Arrays.copyOf(this.array, 0);
        this.array = newArray;

    }

    public void set(int index, T t){
        array[index] = t;
    }

    public boolean isEmpty(){
        for(int i = 0; i < array.length; i++){
            if(array[i] == null){
                return true;
            }

        }
        return false;
    }

    public boolean contains(T t){
      for(int i = 0; i < array.length; i++){
          if(array[i] == t){
              return true;
          }
      }
      return false;
    }

}
